<template>
  <div class="ob-spot__wrap">
    <i class="icon close" v-if="idElem !== 0" @click="removePoint"></i>
    <div class="subtitle"><i class="icon route-loading"
                             :class="`route-${icon} ${titleInfo.color}`"></i>{{ titleInfo.label }}
    </div>

    <div class="ob-spot__row">
      <div class="ob-spot__col-2-1">
        <ob-address-input
            :title="'Адрес'"
            display-exp="russian_address"
            :address="pointInfo.addressTitle"
            :mapId="`map-${titleInfo.key}-${idElem}`"
            :popoverMessage="'Error message for invalid address'"
            placeholder="Например, Мосфильмовская ул., 17, Москва, Россия, 119590"
            prefixIcon="pin"
            :required="idElem === 0"
            :showMap="true"
            :disabled="false"
            :key="`${titleInfo.key}-${idElem}`"
            :data-qa="`map-${titleInfo.key}-${idElem}`"
            @input="onChangeAddress"
            @on-change-address="onChangeAddress"
        />
      </div>
      <div class="ob-spot__col-2-3">

        <ob-date-picker
            :value="pointInfo.arrivalDt"
            placeholder="Укажите"
            label="Дата и время (UTC+3)"
            :readonly="false"
            :is-time="true"
            :block-before="true"
            :since-to="disabledDates"
            :key="`calendar-${titleInfo.key}-${idElem}`"
            :data-qa="`calendar-${titleInfo.key}-${idElem}`"
            @input="onChangeDate"
        />
      </div>
    </div>
  </div>
</template>

<script>
import debounce from 'debounce';
import { uuid } from 'vue-uuid';
import ObAddressInput from 'common-components/src/obComponents/obAddressInput/index'
import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor/index'

export default {
  name: 'spotDraftPoint',
  components: {
    ObDatePicker,
    ObAddressInput
  },
  props: {
    titleInfo: {
      type: Object,
      default: () => {
        return {
          label: '',
          color: '',
          key: ''
        }
      }
    },
    idElem: {
      type: Number,
      default: null
    },
    pointInfo: {
      type: Object,
      default: () => {}
    }
  },
  computed: {
    icon () {
      return this.titleInfo.key === 'loaded' ? 'loading' : 'unloading'
    },
    disabledDates () {
      let _d = new Date()
      if (this.pointInfo.pointType === 'UNLOADING') {
        _d = new Date(this.pointInfo.arrivalDt || null)
      }
      return [{
        from: new Date(1976, 0, 0).toISOString(),
        to: (new Date(_d.setDate(_d.getDate() - 1))).toISOString()
      }]
    }
  },
  methods: {
    removePoint (id) {
      this.$emit('remove', id)
    },
    onChangeAddress: debounce(function(point) {
      if (point === '') {
        this.onComplete({
          addressCoordinates: null,
          addressTitle: null,
          locationUuid: null,
          locationTitle: null,
          pointUuid: uuid.v4()
        })
      } else {
        this.onComplete({
          addressCoordinates: point.coordinates,
          addressTitle: point.label,
          locationUuid: point.locationUuid,
          locationTitle: point.locationTitle || point.label
        })
      }
    }, 500),
    onChangeDate: debounce(function(date) {
      if (date !== "") {
        this.onComplete({ arrivalDt: date })
      }
    }, 500),
    onComplete (data) {
      this.$emit('change', {
        ...this.pointInfo, ...data
      })
    }
  }
}
</script>

<style lang="scss" scoped>
.ob-spot {
  &__wrap {
    overflow: hidden;
    position: relative;

    &:not(:nth-child(1)) {
      padding: 11px 20px 0;
      margin-right: -20px;
    }

    &:not(:nth-child(1)):hover {
      background-color: $color-white-lilac;
    }

    .icon.close {
      position: absolute;
      right: 23px;
      top: 13px;
      font-size: 10px;
      color: $color-grey-span;

      &:hover {
        color: $color-error;
        cursor: pointer;
      }
    }
  }

  &__row {
    width: 100%;
    display: flex;
    margin: 10px 0 10px;

    &.__center {
      align-items: center;
    }

    [class*="__col"]:not(:last-child) {
      margin-right: 10px;
    }
  }

  &__col {
    &-1 {
      flex-basis: 100%;
    }

    &-2-1 {
      flex-basis: 70%;
      flex-grow: 1;
    }

    &-2-2 {
      position: relative;
      z-index: 1;
      height: 52px;
      flex-grow: 1;
    }

    &-3-1 {
      flex: 1 0 32%;

      &-1 {
        flex-basis: 32%;
      }

      &-2 {
        flex-basis: 32%;
      }

      &-3 {
        flex-basis: 32%;
      }
    }

    &-3-2 {
      flex-basis: 52%;
      flex-grow: 1;
    }

    &-3-3 {
      flex-basis: 160px;
    }
  }

  .subtitle {
    font-size: 16px;
    font-weight: bold;
    margin-bottom: 12px;

    .icon {
      font-size: 15px;
      padding-right: 10px;
    }
  }

  .icon {
    &.green {
      color: $color-green-light;
    }

    &.grey {
      color: $color-grey-border;
    }

    &.orange {
      color: $diamond-orange-yellow;
    }
  }
}
</style>
